hdu 5546 Ancient Go【dfs】【思维】

mengxiang000000 · · 1530 次点击 · · 开始浏览    
这是一个创建于 的文章,其中的信息可能已经有所发展或是发生改变。

Ancient Go

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 604    Accepted Submission(s): 221


Problem Description
Yu Zhou likes to play Go with Su Lu. From the historical research, we found that there are much difference on the rules between ancient go and modern go.

Here is the rules for ancient go they were playing:

The game is played on a 8×8 cell board, the chess can be put on the intersection of the board lines, so there are 9×9 different positions to put the chess.
Yu Zhou always takes the black and Su Lu the white. They put the chess onto the game board alternately.
The chess of the same color makes connected components(connected by the board lines), for each of the components, if it's not connected with any of the empty cells, this component dies and will be removed from the game board.
When one of the player makes his move, check the opponent's components first. After removing the dead opponent's components, check with the player's components and remove the dead components.
One day, Yu Zhou was playing ancient go with Su Lu at home. It's Yu Zhou's move now. But they had to go for an emergency military action. Little Qiao looked at the game board and would like to know whether Yu Zhou has a move to kill at least one of Su Lu's chess.
 


Input
The first line of the input gives the number of test cases, T(1T100). T test cases follow. Test cases are separated by an empty line. Each test case consist of 9 lines represent the game board. Each line consists of 9 characters. Each character represents a cell on the game board. . represents an empty cell. x represents a cell with black chess which owned by Yu Zhou. o represents a cell with white chess which owned by Su Lu.
 


Output
For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is Can kill in one move!!! if Yu Zhou has a move to kill at least one of Su Lu's components. Can not kill in one move!!! otherwise.
 


Sample Input
2 .......xo ......... ......... ..x...... .xox....x .o.o...xo ..o...... .....xxxo ....xooo. ......ox. .......o. ...o..... ..o.o.... ...o..... ......... .......o. ...x..... ........o
 


Sample Output
Case #1: Can kill in one move!!! Case #2: Can not kill in one move!!!
Hint
In the first test case, Yu Zhou has 4 different ways to kill Su Lu's component. In the second test case, there is no way to kill Su Lu's component.


开始做题并不是那么谨慎,觉得题目并不是很难,所以WA了几发,一会再强调一下坑点。

首先我们在这里说明一下题意:

给你OX两种棋子,假设你是X,你要只用一个棋子就能围上一个O,那么就算是can kill,否则can not。

这样就算作围上了:

.x.

xox.

.x.

思路:地图辣么小,直接暴力枚举每一个O,看看他周围有几个。就行了,如果只有一个。那么我用X填补上这个。就算作可以one move kill了被~,否则如果有两个以上的。那就说明这个O不能被one kill了被~。当然如果遇到了联通块O,那么我们就无限延展联通块并且找。就行了被~

这里有个坑(连通块的坑)如果是这样的一个图:

这里哪个唯一的一个。容易被忽略而统计两次,所以在dfs核心代码的地方我做了这样的一个小技巧:

char a[15][15];
int vis[15][15];
int fx[4]={0,0,1,-1};
int fy[4]={1,-1,0,0};
int dfs(int x,int y)
{
    int sum=0;
    vis[x][y]=1;
    for(int i=0;i<4;i++)
    {
        int xx=x+fx[i];
        int yy=y+fy[i];
        if(xx>=0&&xx<9&&yy>=0&&yy<9&&vis[xx][yy]==0)
        {
            if(a[xx][yy]=='.')
            {
                sum++;
                vis[xx][yy]=1;//在这里,我们把走过的。也标记上,就不会统计多次了~。当然这么做同时也要在每一次枚举o的时候都要memset一下vis。
                //printf("%d %d\n",xx,yy);
            }
            if(a[xx][yy]=='x')
            continue;
            if(a[xx][yy]=='o')
            {
               sum+=dfs(xx,yy);
            }
        }
    }
    return sum;
}

思路清晰了,我们这里就直接上完整的AC代码了:

 

#include<stdio.h>
#include<string.h>
using namespace std;
char a[15][15];
int vis[15][15];
int fx[4]={0,0,1,-1};
int fy[4]={1,-1,0,0};
int dfs(int x,int y)
{
    int sum=0;
    vis[x][y]=1;
    for(int i=0;i<4;i++)
    {
        int xx=x+fx[i];
        int yy=y+fy[i];
        if(xx>=0&&xx<9&&yy>=0&&yy<9&&vis[xx][yy]==0)
        {
            if(a[xx][yy]=='.')
            {
                sum++;
                vis[xx][yy]=1;
                //printf("%d %d\n",xx,yy);
            }
            if(a[xx][yy]=='x')
            continue;
            if(a[xx][yy]=='o')
            {
               sum+=dfs(xx,yy);
            }
        }
    }
    return sum;
}
int main()
{
    int kase=0;
    int t;
    scanf("%d",&t);
    while(t--)
    {
        memset(vis,0,sizeof(vis));
        for(int i=0;i<9;i++)
        {
            scanf("%s",a[i]);
        }
        int ok=0;
        for(int i=0;i<9;i++)
        {
            for(int j=0;j<9;j++)
            {
                if(a[i][j]=='o')
                {
                    memset(vis,0,sizeof(vis));
                    int cont=dfs(i,j);
                    //printf("%d\n",cont);
                    if(cont==1)
                    {
                         printf("Case #%d: Can kill in one move!!!\n",++kase);
                         //printf("%d %d yes\n",i,j);
                         ok=1;
                    }
                    //printf("%d %d yes\n",i,j);
                }
                if(ok==1)break;
            }
            if(ok==1)break;
        }
        if(ok==0)
        {
            printf("Case #%d: Can not kill in one move!!!\n",++kase);
        }
    }
}
/*
.........
.........
.........
.........
...xxx...
..xooox..
..xxo....
....x....
.........
*/






有疑问加站长微信联系(非本文作者)

本文来自:CSDN博客

感谢作者:mengxiang000000

查看原文:hdu 5546 Ancient Go【dfs】【思维】

入群交流(和以上内容无关):加入Go大咖交流群,或添加微信:liuxiaoyan-s 备注:入群;或加QQ群:692541889

1530 次点击  
加入收藏 微博
暂无回复
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传